-------------------------------------------------------------------------------
-- Copyright (c) 2005 Xilinx, Inc.
-- This design is confidential and proprietary of Xilinx, All Rights Reserved.
-------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /   Vendor: Xilinx
-- \   \   \/    Version: 1.0
--  \   \        Filename: phase_meter.vhd
--  /   /        Date Last Modified:  Thu Jan 17 2008
-- /___/   /\    Date Created: Wed May 2 2007
-- \   \  /  \
--  \___\/\___\
-- 
--Device: Virtex-5
--Purpose: This is a phase meter, only for the testbench 
--         
--         
--Revision History:
--    Rev 1.0 - First created, P. Novellini and G. Guasti, Wed May 2 2007.
------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.MATH_COMPLEX.ALL;
use IEEE.MATH_REAL.ALL;
library MODELSIM_LIB;
use MODELSIM_LIB.util.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity ph_meter is
    Port ( in_sig_1 : in  STD_LOGIC;
    	   in_sig_2 : in  STD_LOGIC;	
           out_ph1 : out  REAL);
end ph_meter;

architecture Behavioral of ph_meter is

begin



PROCESS (in_sig_1, in_sig_2)
-- START DECLARATIONS
VARIABLE strt,stp,diff: time:=0 ps;
VARIABLE alt: BOOLEAN:=FALSE;
-- END DECLARATIONS
begin
if in_sig_1='1' and in_sig_1'event then
		strt:=NOW;
		alt:=TRUE;
end if;
if in_sig_2='1' and in_sig_2'event then
		stp:=NOW;
		alt:=FALSE;
		out_ph1<=to_real(stp-strt)/0.5e6;
end if; 


end PROCESS;



end Behavioral;

